<?php

/**
 * Functions which enhance the theme by hooking into WordPress
 *
 * @package florist_bouquet
 */

function florist_bouquet_body_classes( $florist_bouquet_classes ) {
	// Adds a class of hfeed to non-singular pages.
	if ( ! is_singular() ) {
		$florist_bouquet_classes[] = 'hfeed';
	}

	// Adds a class of no-sidebar when there is no sidebar present.
	if ( ! is_active_sidebar( 'sidebar-1' ) ) {
		$florist_bouquet_classes[] = 'no-sidebar';
	}

	$florist_bouquet_classes[] = florist_bouquet_sidebar_layout();

	return $florist_bouquet_classes;
}
add_filter( 'body_class', 'florist_bouquet_body_classes' );

/**
 * Add a pingback url auto-discovery header for single posts, pages, or attachments.
 */
function florist_bouquet_pingback_header() {
	if ( is_singular() && pings_open() ) {
		printf( '<link rel="pingback" href="%s">', esc_url( get_bloginfo( 'pingback_url' ) ) );
	}
}
add_action( 'wp_head', 'florist_bouquet_pingback_header' );


/**
 * Get all posts for customizer Post content type.
 */
function florist_bouquet_get_post_choices() {
	$florist_bouquet_choices = array( '' => esc_html__( '--Select--', 'florist-bouquet' ) );
	$florist_bouquet_args    = array( 'numberposts' => -1 );
	$florist_bouquet_posts   = get_posts( $florist_bouquet_args );

	foreach ( $florist_bouquet_posts as $florist_bouquet_post ) {
		$florist_bouquet_id             = $florist_bouquet_post->ID;
		$florist_bouquet_title          = $florist_bouquet_post->post_title;
		$florist_bouquet_choices[ $florist_bouquet_id ] = $florist_bouquet_title;
	}

	return $florist_bouquet_choices;
}

/**
 * Get all pages for customizer Page content type.
 */
function florist_bouquet_get_page_choices() {
	$florist_bouquet_choices = array( '' => esc_html__( '--Select--', 'florist-bouquet' ) );
	$florist_bouquet_pages   = get_pages();

	foreach ( $florist_bouquet_pages as $florist_bouquet_page ) {
		$florist_bouquet_choices[ $florist_bouquet_page->ID ] = $florist_bouquet_page->post_title;
	}

	return $florist_bouquet_choices;
}

/**
 * Get all categories for customizer Category content type.
 */
function florist_bouquet_get_post_cat_choices() {
	$florist_bouquet_choices = array( '' => esc_html__( '--Select--', 'florist-bouquet' ) );
	$florist_bouquet_cats    = get_categories();

	foreach ( $florist_bouquet_cats as $florist_bouquet_cat ) {
		$florist_bouquet_choices[ $florist_bouquet_cat->term_id ] = $florist_bouquet_cat->name;
	}

	return $florist_bouquet_choices;
}

/**
 * Get all donation forms for customizer form content type.
 */
function florist_bouquet_get_post_donation_form_choices() {
	$florist_bouquet_choices = array( '' => esc_html__( '--Select--', 'florist-bouquet' ) );
	$florist_bouquet_posts   = get_posts(
		array(
			'post_type'   => 'give_forms',
			'numberposts' => -1,
		)
	);
	foreach ( $florist_bouquet_posts as $florist_bouquet_post ) {
		$florist_bouquet_choices[ $florist_bouquet_post->ID ] = $florist_bouquet_post->post_title;
	}
	return $florist_bouquet_choices;
}

if ( ! function_exists( 'florist_bouquet_excerpt_length' ) ) :
	/**
	 * Excerpt length.
	 */
	function florist_bouquet_excerpt_length( $florist_bouquet_length ) {
		if ( is_admin() ) {
			return $florist_bouquet_length;
		}

		return get_theme_mod( 'florist_bouquet_excerpt_length', 20 );
	}
endif;
add_filter( 'excerpt_length', 'florist_bouquet_excerpt_length', 999 );

if ( ! function_exists( 'florist_bouquet_excerpt_more' ) ) :
	/**
	 * Excerpt more.
	 */
	function florist_bouquet_excerpt_more( $florist_bouquet_more ) {
		if ( is_admin() ) {
			return $florist_bouquet_more;
		}

		return '&hellip;';
	}
endif;
add_filter( 'excerpt_more', 'florist_bouquet_excerpt_more' );

if ( ! function_exists( 'florist_bouquet_sidebar_layout' ) ) {
	/**
	 * Get sidebar layout.
	 */
	function florist_bouquet_sidebar_layout() {
		$florist_bouquet_sidebar_position      = get_theme_mod( 'florist_bouquet_sidebar_position', 'right-sidebar' );
		$florist_bouquet_sidebar_position_post = get_theme_mod( 'florist_bouquet_post_sidebar_position', 'right-sidebar' );
		$florist_bouquet_sidebar_position_page = get_theme_mod( 'florist_bouquet_page_sidebar_position', 'right-sidebar' );

		if ( is_single() ) {
			$florist_bouquet_sidebar_position = $florist_bouquet_sidebar_position_post;
		} elseif ( is_page() ) {
			$florist_bouquet_sidebar_position = $florist_bouquet_sidebar_position_page;
		}

		return $florist_bouquet_sidebar_position;
	}
}

if ( ! function_exists( 'florist_bouquet_is_sidebar_enabled' ) ) {
	/**
	 * Check if sidebar is enabled.
	 */
	function florist_bouquet_is_sidebar_enabled() {
		$florist_bouquet_sidebar_position      = get_theme_mod( 'florist_bouquet_sidebar_position', 'right-sidebar' );
		$florist_bouquet_sidebar_position_post = get_theme_mod( 'florist_bouquet_post_sidebar_position', 'right-sidebar' );
		$florist_bouquet_sidebar_position_page = get_theme_mod( 'florist_bouquet_page_sidebar_position', 'right-sidebar' );

		$florist_bouquet_sidebar_enabled = true;
		if ( is_home() || is_archive() || is_search() ) {
			if ( 'no-sidebar' === $florist_bouquet_sidebar_position ) {
				$florist_bouquet_sidebar_enabled = false;
			}
		} elseif ( is_single() ) {
			if ( 'no-sidebar' === $florist_bouquet_sidebar_position || 'no-sidebar' === $florist_bouquet_sidebar_position_post ) {
				$florist_bouquet_sidebar_enabled = false;
			}
		} elseif ( is_page() ) {
			if ( 'no-sidebar' === $florist_bouquet_sidebar_position || 'no-sidebar' === $florist_bouquet_sidebar_position_page ) {
				$florist_bouquet_sidebar_enabled = false;
			}
		}
		return $florist_bouquet_sidebar_enabled;
	}
}

if ( ! function_exists( 'florist_bouquet_get_homepage_sections ' ) ) {
	/**
	 * Returns homepage sections.
	 */
	function florist_bouquet_get_homepage_sections() {
		$florist_bouquet_sections = array(
			'banner'  => esc_html__( 'Banner Section', 'florist-bouquet' ),
			'about' => esc_html__( 'About Us Section', 'florist-bouquet' ),
		);
		return $florist_bouquet_sections;
	}
}

/**
 * Renders customizer section link
 */
function florist_bouquet_section_link( $florist_bouquet_section_id ) {
	$florist_bouquet_section_name      = str_replace( 'florist_bouquet_', ' ', $florist_bouquet_section_id );
	$florist_bouquet_section_name      = str_replace( '_', ' ', $florist_bouquet_section_name );
	$florist_bouquet_starting_notation = '#';
	?>
	<span class="section-link">
		<span class="section-link-title"><?php echo esc_html( $florist_bouquet_section_name ); ?></span>
	</span>
	<style type="text/css">
		<?php echo $florist_bouquet_starting_notation . $florist_bouquet_section_id; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped ?>:hover .section-link {
			visibility: visible;
		}
	</style>
	<?php
}

/**
 * Adds customizer section link css
 */
function florist_bouquet_section_link_css() {
	if ( is_customize_preview() ) {
		?>
		<style type="text/css">
			.section-link {
				visibility: hidden;
				background-color: black;
				position: relative;
				top: 80px;
				z-index: 99;
				left: 40px;
				color: #fff;
				text-align: center;
				font-size: 20px;
				border-radius: 10px;
				padding: 20px 10px;
				text-transform: capitalize;
			}

			.section-link-title {
				padding: 0 10px;
			}

			.banner-section {
				position: relative;
			}

			.banner-section .section-link {
				position: absolute;
				top: 100px;
			}
		</style>
		<?php
	}
}
add_action( 'wp_head', 'florist_bouquet_section_link_css' );

/**
 * Breadcrumb.
 */
function florist_bouquet_breadcrumb( $florist_bouquet_args = array() ) {
	if ( ! get_theme_mod( 'florist_bouquet_enable_breadcrumb', true ) ) {
		return;
	}

	$florist_bouquet_args = array(
		'show_on_front' => false,
		'show_title'    => true,
		'show_browse'   => false,
	);
	breadcrumb_trail( $florist_bouquet_args );
}
add_action( 'florist_bouquet_breadcrumb', 'florist_bouquet_breadcrumb', 10 );

/**
 * Add separator for breadcrumb trail.
 */
function florist_bouquet_breadcrumb_trail_print_styles() {
	$florist_bouquet_breadcrumb_separator = get_theme_mod( 'florist_bouquet_breadcrumb_separator', '/' );

	$florist_bouquet_style = '
		.trail-items li::after {
			content: "' . $florist_bouquet_breadcrumb_separator . '";
		}'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped

	$florist_bouquet_style = apply_filters( 'florist_bouquet_breadcrumb_trail_inline_style', trim( str_replace( array( "\r", "\n", "\t", '  ' ), '', $florist_bouquet_style ) ) );

	if ( $florist_bouquet_style ) {
		echo "\n" . '<style type="text/css" id="breadcrumb-trail-css">' . $florist_bouquet_style . '</style>' . "\n"; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}
}
add_action( 'wp_head', 'florist_bouquet_breadcrumb_trail_print_styles' );

/**
 * Pagination for archive.
 */
function florist_bouquet_render_posts_pagination() {
	$florist_bouquet_is_pagination_enabled = get_theme_mod( 'florist_bouquet_enable_pagination', true );
	if ( $florist_bouquet_is_pagination_enabled ) {
		$florist_bouquet_pagination_type = get_theme_mod( 'florist_bouquet_pagination_type', 'default' );
		if ( 'default' === $florist_bouquet_pagination_type ) :
			the_posts_navigation();
		else :
			the_posts_pagination();
		endif;
	}
}
add_action( 'florist_bouquet_posts_pagination', 'florist_bouquet_render_posts_pagination', 10 );

/**
 * Pagination for single post.
 */
function florist_bouquet_render_post_navigation() {
	the_post_navigation(
		array(
			'prev_text' => '<span>&#10229;</span> <span class="nav-title">%title</span>',
			'next_text' => '<span class="nav-title">%title</span> <span>&#10230;</span>',
		)
	);
}
add_action( 'florist_bouquet_post_navigation', 'florist_bouquet_render_post_navigation' );

/**
 * Adds footer copyright text.
 */

function florist_bouquet_output_footer_copyright_content() {
    $florist_bouquet_theme_data = wp_get_theme();
    $florist_bouquet_copyright_text = get_theme_mod('florist_bouquet_footer_copyright_text');

    if (!empty($florist_bouquet_copyright_text)) {
        $florist_bouquet_text = $florist_bouquet_copyright_text;
    } else {
        $florist_bouquet_default_text = '<a href="'. esc_url(__('https://asterthemes.com/products/free-florist-wordpress-theme','florist-bouquet')) . '" target="_blank"> ' . esc_html($florist_bouquet_theme_data->get('Name')) . '</a>' . '&nbsp;' . esc_html__('by', 'florist-bouquet') . '&nbsp;<a target="_blank" href="' . esc_url($florist_bouquet_theme_data->get('AuthorURI')) . '">' . esc_html(ucwords($florist_bouquet_theme_data->get('Author'))) . '</a>';
		/* translators: %s: WordPress.org URL */
        $florist_bouquet_default_text .= sprintf(esc_html__(' | Powered by %s', 'florist-bouquet'), '<a href="' . esc_url(__('https://wordpress.org/', 'florist-bouquet')) . '" target="_blank">WordPress</a>. ');

        $florist_bouquet_text = $florist_bouquet_default_text;
    }
    ?>
    <span><?php echo wp_kses_post($florist_bouquet_text); ?></span>
    <?php
}
add_action('florist_bouquet_footer_copyright', 'florist_bouquet_output_footer_copyright_content');

/* Footer Social Icons */ 
function florist_bouquet_footer_social_links() {

    if ( get_theme_mod('florist_bouquet_enable_footer_icon_section', true) ) {

            ?>
            <div class="socialicons">
                <?php if ( get_theme_mod('florist_bouquet_footer_facebook_link', 'https://www.facebook.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('florist_bouquet_footer_facebook_link', 'https://www.facebook.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('florist_bouquet_facebook_icon', 'fab fa-facebook-f')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Facebook', 'florist-bouquet'); ?></span>
                    </a>
                <?php } ?>
                <?php if ( get_theme_mod('florist_bouquet_footer_twitter_link', 'https://x.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('florist_bouquet_footer_twitter_link', 'https://x.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('florist_bouquet_twitter_icon', 'fab fa-twitter')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Twitter', 'florist-bouquet'); ?></span>
                    </a>
                <?php } ?>
				<?php if ( get_theme_mod('florist_bouquet_footer_instagram_link', 'https://www.instagram.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('florist_bouquet_footer_instagram_link', 'https://www.instagram.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('florist_bouquet_instagram_icon', 'fab fa-instagram')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Instagram', 'florist-bouquet'); ?></span>
                    </a>
                <?php } ?>
                <?php if ( get_theme_mod('florist_bouquet_footer_linkedin_link', 'https://in.linkedin.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('florist_bouquet_footer_linkedin_link', 'https://in.linkedin.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('florist_bouquet_linkedin_icon', 'fab fa-linkedin')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Linkedin', 'florist-bouquet'); ?></span>
                    </a>
                <?php } ?>
				<?php if ( get_theme_mod('florist_bouquet_footer_youtube_link', 'https://www.youtube.com/') != '' ) { ?>
                    <a target="_blank" href="<?php echo esc_url(get_theme_mod('florist_bouquet_footer_youtube_link', 'https://www.youtube.com/')); ?>">
                        <i class="<?php echo esc_attr(get_theme_mod('florist_bouquet_youtube_icon', 'fab fa-youtube')); ?>"></i>
                        <span class="screen-reader-text"><?php esc_html_e('Youtube', 'florist-bouquet'); ?></span>
                    </a>
                <?php } ?>
            </div>
            <?php
    }
}
add_action('wp_footer', 'florist_bouquet_footer_social_links');

/**
 * GET START FUNCTION
 */

function florist_bouquet_getpage_css($hook) {
	wp_enqueue_script( 'florist-bouquet-admin-script', get_template_directory_uri() . '/resource/js/florist-bouquet-admin-notice-script.js', array( 'jquery' ) );
    wp_localize_script( 'florist-bouquet-admin-script', 'florist_bouquet_ajax_object',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
    wp_enqueue_style( 'florist-bouquet-notice-style', get_template_directory_uri() . '/resource/css/notice.css' );
}

add_action( 'admin_enqueue_scripts', 'florist_bouquet_getpage_css' );

add_action('wp_ajax_florist_bouquet_dismissable_notice', 'florist_bouquet_dismissable_notice');
	function florist_bouquet_switch_theme() {
	    delete_user_meta(get_current_user_id(), 'florist_bouquet_dismissable_notice');
	}
	add_action('after_switch_theme', 'florist_bouquet_switch_theme');
	function florist_bouquet_dismissable_notice() {
	    update_user_meta(get_current_user_id(), 'florist_bouquet_dismissable_notice', true);
	    die();
	}


function florist_bouquet_deprecated_hook_admin_notice() {
    global $florist_bouquet_pagenow;
    
    // Check if the current page is the one where you don't want the notice to appear
    if ( $florist_bouquet_pagenow === 'themes.php' && isset( $_GET['page'] ) && $_GET['page'] === 'florist-bouquet-getting-started' ) {
        return;
    }

    $florist_bouquet_dismissed = get_user_meta( get_current_user_id(), 'florist_bouquet_dismissable_notice', true );
    if ( !$florist_bouquet_dismissed) { ?>
        <div class="getstrat updated notice notice-success is-dismissible notice-get-started-class">
            <div class="at-admin-content" >
                <h2><?php esc_html_e('Welcome to Florist Bouquet', 'florist-bouquet'); ?></h2>
                <p><?php _e('Explore the features of our Pro Theme and take your Florist journey to the next level.', 'florist-bouquet'); ?></p>
                <p ><?php _e('Get Started With Theme By Clicking On Getting Started.', 'florist-bouquet'); ?><p>
                <div style="display: flex; justify-content: center; align-items:center; flex-wrap: wrap; gap: 5px">
                    <a class="admin-notice-btn button button-primary button-hero" href="<?php echo esc_url( admin_url( 'themes.php?page=florist-bouquet-getting-started' )); ?>"><?php esc_html_e( 'Get started', 'florist-bouquet' ) ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="https://demo.asterthemes.com/florist-bouquet"><?php esc_html_e('View Demo', 'florist-bouquet') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="https://asterthemes.com/products/bouquet-wordpress-theme"><?php esc_html_e('Buy Now', 'florist-bouquet') ?></a>
                    <a  class="admin-notice-btn button button-primary button-hero" target="_blank" href="<?php echo esc_url( FLORIST_BOUQUET_BUNDLE_PAGE ); ?>"><?php esc_html_e('Get Bundle', 'florist-bouquet') ?></a>
                </div>
            </div>
            <div class="at-admin-image">
                <img style="width: 100%;max-width: 320px;line-height: 40px;display: inline-block;vertical-align: top;border: 2px solid #ddd;border-radius: 4px;" src="<?php echo esc_url(get_stylesheet_directory_uri()) .'/screenshot.png'; ?>" />
            </div>
        </div>
    <?php }
}

add_action( 'admin_notices', 'florist_bouquet_deprecated_hook_admin_notice' );


//Admin Notice For Getstart
function florist_bouquet_ajax_notice_handler() {
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}

if ( ! function_exists( 'florist_bouquet_footer_widget' ) ) :
	function florist_bouquet_footer_widget() {
		$florist_bouquet_footer_widget_column = get_theme_mod('florist_bouquet_footer_widget_column','4');

		$florist_bouquet_column_class = '';
		if ($florist_bouquet_footer_widget_column == '1') {
			$florist_bouquet_column_class = 'one-column';
		} elseif ($florist_bouquet_footer_widget_column == '2') {
			$florist_bouquet_column_class = 'two-columns';
		} elseif ($florist_bouquet_footer_widget_column == '3') {
			$florist_bouquet_column_class = 'three-columns';
		} else {
			$florist_bouquet_column_class = 'four-columns';
		}
	
		if($florist_bouquet_footer_widget_column !== ''): 
		?>
		<div class="dt_footer-widgets <?php echo esc_attr($florist_bouquet_column_class); ?> wow bounceInUp delay-1000" data-wow-duration="2s">
			<div class="footer-widgets-column">
				<?php
				$footer_widgets_active = false;

				// Loop to check if any footer widget is active
				for ($i = 1; $i <= $florist_bouquet_footer_widget_column; $i++) {
					if (is_active_sidebar('florist-bouquet-footer-widget-' . $i)) {
						$footer_widgets_active = true;
						break;
					}
				}

				if ($footer_widgets_active) {
					// Display active footer widgets
					for ($i = 1; $i <= $florist_bouquet_footer_widget_column; $i++) {
						if (is_active_sidebar('florist-bouquet-footer-widget-' . $i)) : ?>
							<div class="footer-one-column">
								<?php dynamic_sidebar('florist-bouquet-footer-widget-' . $i); ?>
							</div>
						<?php endif;
					}
				} else {
				?>
				<div class="footer-one-column default-widgets">
					<aside id="search-2" class="widget widget_search default_footer_search">
						<div class="widget-header">
							<h4 class="widget-title"><?php esc_html_e('Search Here', 'florist-bouquet'); ?></h4>
						</div>
						<?php get_search_form(); ?>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-posts-2" class="widget widget_recent_entries">
						<h2 class="widget-title"><?php esc_html_e('Recent Posts', 'florist-bouquet'); ?></h2>
						<ul>
							<?php
							$recent_posts = wp_get_recent_posts(array(
								'numberposts' => 5,
								'post_status' => 'publish',
							));
							foreach ($recent_posts as $post) {
								echo '<li><a href="' . esc_url(get_permalink($post['ID'])) . '">' . esc_html($post['post_title']) . '</a></li>';
							}
							wp_reset_query();
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="recent-comments-2" class="widget widget_recent_comments">
						<h2 class="widget-title"><?php esc_html_e('Recent Comments', 'florist-bouquet'); ?></h2>
						<ul>
							<?php
							$recent_comments = get_comments(array(
								'number' => 5,
								'status' => 'approve',
							));
							foreach ($recent_comments as $comment) {
								echo '<li><a href="' . esc_url(get_comment_link($comment)) . '">' .
									/* translators: %s: details. */
									sprintf(esc_html__('Comment on %s', 'florist-bouquet'), get_the_title($comment->comment_post_ID)) .
									'</a></li>';
							}
							?>
						</ul>
					</aside>
				</div>
				<div class="footer-one-column default-widgets">
					<aside id="calendar-2" class="widget widget_calendar">
						<h2 class="widget-title"><?php esc_html_e('Calendar', 'florist-bouquet'); ?></h2>
						<?php get_calendar(); ?>
					</aside>
				</div>
			</div>
			<?php } ?>
		</div>
		<?php
		endif;
	}
	endif;
add_action( 'florist_bouquet_footer_widget', 'florist_bouquet_footer_widget' );

function florist_bouquet_footer_text_transform_css() {
    $florist_bouquet_footer_text_transform = get_theme_mod('footer_text_transform', 'none');
    ?>
    <style type="text/css">
        .site-footer h4,footer#colophon h2.wp-block-heading,footer#colophon .widgettitle,footer#colophon .widget-title {
            text-transform: <?php echo esc_html($florist_bouquet_footer_text_transform); ?>;
        }
    </style>
    <?php
}
add_action('wp_head', 'florist_bouquet_footer_text_transform_css');